#include "StdAfx.h"
#include "NMImgComboBox.h"

CString CNMImgComboBox::m_strBtnImgPath = _T("");
int CNMImgComboBox::m_nBtnStatusCount = 4;
CFont * CNMImgComboBox::m_font = NULL;
BOOL CNMImgComboBox::m_bDropDownAutoResizing = TRUE;
int CNMImgComboBox::m_nItemHeight = 0;

IMPLEMENT_DYNAMIC(CNMImgComboBox, CComboBox)

CNMImgComboBox::CNMImgComboBox()
{
	m_nBtnState = BTN_STATE_NORMAL;
	m_nWidthDropDown = -1;
	m_nTextDrawStyle = DT_LEFT | DT_SINGLELINE | DT_VCENTER;
	m_crText=-1;
    m_rcBtn.SetRectEmpty();
}

CNMImgComboBox::~CNMImgComboBox()
{
}


BEGIN_MESSAGE_MAP(CNMImgComboBox, CComboBox)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_CONTROL_REFLECT(CBN_DROPDOWN, &CNMImgComboBox::OnCbnDropdown)
END_MESSAGE_MAP()



void CNMImgComboBox::PreSubclassWindow()
{
	if(!m_strBtnImgPath.IsEmpty() && m_nBtnStatusCount > 0)
		LoadUnitedButtonImages(m_strBtnImgPath, m_nBtnStatusCount);

	CComboBox::PreSubclassWindow();

	if(m_nItemHeight != 0)
	{
		CDC* pDC = GetDC();
		int nHeight = CNMImgComboBox::m_nItemHeight * 72 / pDC->GetDeviceCaps(LOGPIXELSY);
		SetItemHeight(-1, nHeight);
		ReleaseDC(pDC);
	}
}

void CNMImgComboBox::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient, rcClientDeflate;
	GetClientRect(&rcClient);
	rcClientDeflate = rcClient;
	rcClientDeflate.DeflateRect(1,1);

	int nWidth = rcClient.Width();
	int nHeight = rcClient.Height();

	CDC dcMem;
	dcMem.CreateCompatibleDC(&dc);
	CBitmap bmpMem;
	bmpMem.CreateCompatibleBitmap(&dc, nWidth, nHeight);
	dcMem.SelectObject(&bmpMem);

	dcMem.FillSolidRect(rcClient, RGB(255,255,255));
	dcMem.FillSolidRect(rcClientDeflate, RGB(255,255,255));

	//Set Font
	if(m_font)
		dcMem.SelectObject(m_font);
	else
		dcMem.SelectObject(GetFont());

	//DrawText, Text ׷ ִµ, ̰ ComboBox DropList϶ δ. 
	//DropDown϶ Ʈ ڽ  Ƿ ʿ .    
	CString strText;
	GetWindowText(strText);
	rcClientDeflate.left += 5;	//ʿ پ   .
	COMBOBOXINFO cbi;
	cbi.cbSize = sizeof(COMBOBOXINFO);
	GetComboBoxInfo(&cbi);

	rcClientDeflate.right = rcClientDeflate.left + (cbi.rcItem.right - cbi.rcItem.left);	//  ư κ Ѵ.
	if(!strText.IsEmpty())
	{
		if(m_crText != -1)	// Text  
			dcMem.SetTextColor(m_crText);
		dcMem.DrawText(strText, rcClientDeflate, m_nTextDrawStyle);
	}

	//DrawButton
	CBitmap * pBmpButton;
	switch(m_nBtnState)
	{
	case BTN_STATE_NORMAL:
		pBmpButton = &m_bmpBtnNormal;
		break;
	case BTN_STATE_CLICKED:
		pBmpButton = &m_bmpBtnClicked;
		break;
	case BTN_STATE_HOVER:
		pBmpButton = &m_bmpBtnHover;
		break;
	case BTN_STATE_SELECTED:
		pBmpButton = &m_bmpBtnSelected;
		break;
	case BTN_STATE_DISABLED:
		pBmpButton = &m_bmpBtnDisabled;
		break;
	default:
		pBmpButton = &m_bmpBtnNormal;
	}

	if(pBmpButton->GetSafeHandle())
	{
		m_rcBtn = cbi.rcButton;

		BITMAP bmInfo;
		pBmpButton->GetBitmap(&bmInfo);

		CRect rcBtn = m_rcBtn;
		rcBtn.DeflateRect((m_rcBtn.Width() - bmInfo.bmWidth)/2, (m_rcBtn.Height() - bmInfo.bmHeight)/2);

		CDC dcBtn;
		dcBtn.CreateCompatibleDC(&dc);
		dcBtn.SelectObject(pBmpButton);

		dcMem.TransparentBlt(rcBtn.left, rcBtn.top, rcBtn.Width(), rcBtn.Height(), 
			&dcBtn, 0, 0, bmInfo.bmWidth, bmInfo.bmHeight, RGB(255,0,255));

	}

	dc.BitBlt(0, 0, nWidth, nHeight, &dcMem, 0, 0, SRCCOPY);
}

void CNMImgComboBox::SetFontStatic(CFont * font) 
{
	m_font = font;
}

void CNMImgComboBox::SetTextDrawStyle(UINT nDrawStyle)
{
	m_nTextDrawStyle = nDrawStyle;
}

void CNMImgComboBox::SetUnitedButtonImagesStatic(LPCTSTR pszBtnImgPath, int nStatusCount) 
{
	m_strBtnImgPath = pszBtnImgPath;
	m_nBtnStatusCount = nStatusCount;
}

BOOL CNMImgComboBox::LoadUnitedButtonImages(LPCTSTR pszBtnImgPath, int nStatusCount)
{
	if( (nStatusCount<=0)||(nStatusCount>=6) )
		return FALSE;

	CString strPath(pszBtnImgPath);
	ChangeToWorkingDirectory(strPath);

	CImage imgUnited;
	if(imgUnited.Load(strPath)!=S_OK)
		return FALSE;

	m_bmpBtnNormal.DeleteObject();
	m_bmpBtnClicked.DeleteObject();
	m_bmpBtnHover.DeleteObject();
	m_bmpBtnSelected.DeleteObject();
	m_bmpBtnDisabled.DeleteObject();

	CDC* pDC = GetDC();

	CDC dc;
	dc.CreateCompatibleDC(pDC);

	CBitmap *pBitmap = NULL;

	int nWidth=imgUnited.GetWidth()/nStatusCount;
	int nHeight=imgUnited.GetHeight();

	for( int i=0; i < nStatusCount; ++i )
	{
		switch( i )
		{
		case 0: //normal
			m_bmpBtnNormal.CreateCompatibleBitmap( pDC, nWidth, nHeight );
			pBitmap = &m_bmpBtnNormal;
			break;
		case 1: //clicked
			m_bmpBtnClicked.CreateCompatibleBitmap( pDC, nWidth, nHeight );
			pBitmap = &m_bmpBtnClicked;
			break;
		case 2: //hover(selected)
			m_bmpBtnHover.CreateCompatibleBitmap( pDC, nWidth, nHeight );
			pBitmap = &m_bmpBtnHover;
			break;
		case 3: //disable or selected
			if( nStatusCount < 5 )
			{
				m_bmpBtnDisabled.CreateCompatibleBitmap( pDC, nWidth, nHeight );
				pBitmap=&m_bmpBtnDisabled;
			}
			else
			{
				m_bmpBtnSelected.CreateCompatibleBitmap( pDC, nWidth, nHeight );
				pBitmap = &m_bmpBtnSelected;
			}
			break;
		case 4: //disable
			m_bmpBtnDisabled.CreateCompatibleBitmap( pDC, nWidth, nHeight );
			pBitmap = &m_bmpBtnDisabled;
			break;
        default:
            ASSERT(FALSE);
            break;
		}
        if (pBitmap)
        {
            dc.SelectObject(pBitmap);
            imgUnited.BitBlt(dc.GetSafeHdc(), 0, 0, nWidth, nHeight, i*nWidth, 0);
        }
	}

	dc.DeleteDC();
	ReleaseDC(pDC);

	return TRUE;
}
void CNMImgComboBox::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_nBtnState = BTN_STATE_CLICKED;

	CComboBox::OnLButtonDown(nFlags, point);
}

void CNMImgComboBox::OnMouseMove(UINT nFlags, CPoint point)
{
	if(m_rcBtn.PtInRect(point))
	{
		m_nBtnState = BTN_STATE_HOVER;
		InvalidateRect(m_rcBtn);
	}

	TRACKMOUSEEVENT tme;
	tme.cbSize = sizeof(TRACKMOUSEEVENT);
	tme.dwFlags = TME_LEAVE;
	tme.hwndTrack = m_hWnd;
	TrackMouseEvent(&tme);

	CComboBox::OnMouseMove(nFlags, point);
}

LRESULT CNMImgComboBox::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	m_nBtnState = BTN_STATE_NORMAL;
	InvalidateRect(m_rcBtn);
	return 0;
}

void CNMImgComboBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	// CBS_OWNERDRAWFIXED  츸   ׷..
	// OWNER DRAW Ӽ ̸ ؾ (̾α Ʈ)
	if(lpDrawItemStruct->CtlType==ODT_COMBOBOX && lpDrawItemStruct->itemID!=-1)
	{
		CString strItem;
		GetLBText(lpDrawItemStruct->itemID, strItem);

		CRect rcItem = lpDrawItemStruct->rcItem;
		CDC* pDC = CDC::FromHandle( lpDrawItemStruct->hDC );
		if(lpDrawItemStruct->itemState&ODS_SELECTED || lpDrawItemStruct->itemState&ODS_FOCUS || lpDrawItemStruct->itemState&ODS_HOTLIGHT)
		{
			pDC->FillSolidRect(rcItem, GetSysColor(COLOR_ACTIVECAPTION)/*RGB(0,0,255)*/);
			pDC->SetTextColor(COLOR_CB_SELECTED_TEXT);
		}
		else
		{
			pDC->FillSolidRect(rcItem, COLOR_CB_NORMAL_BK);
			pDC->SetTextColor(COLOR_CB_NORMAL_TEXT);
		}

		if(m_font)
			pDC->SelectObject(m_font);
		else
			pDC->SelectObject(GetFont());

		if(!strItem.IsEmpty())
		{
			rcItem.left += 3;	//ʿ  پ   .
			pDC->DrawText(strItem, rcItem, m_nTextDrawStyle);
		}
	}
}

void CNMImgComboBox::SetDropDownResizing(BOOL bAutoResizing)
{
	m_bDropDownAutoResizing = bAutoResizing;
}

void CNMImgComboBox::SetDefaultItemHeight(int nHeight)
{
	m_nItemHeight = nHeight;
}

void CNMImgComboBox::OnCbnDropdown()
{
	if(!m_bDropDownAutoResizing)
		return;

	if(/*m_nWidthDropDown==-1 && */GetStyle()&CBS_HASSTRINGS)
	{
		CDC* pDC = GetDC();
		if(m_font)
			pDC->SelectObject(m_font);
		else
			pDC->SelectObject(GetFont());

		int nCount = GetCount();
		for(int nIndex=0; nIndex<nCount; nIndex++)
		{
			CString strItem;
			GetLBText(nIndex, strItem);

			m_nWidthDropDown = max(m_nWidthDropDown, pDC->GetTextExtent(strItem).cx+5);
		}
		ReleaseDC(pDC);

		COMBOBOXINFO cbi;
		cbi.cbSize = sizeof(COMBOBOXINFO);
		GetComboBoxInfo(&cbi);

		CWnd* pWnd = CWnd::FromHandle(cbi.hwndList);

		if(pWnd && pWnd->GetStyle()&WS_VSCROLL)
		{
			m_nWidthDropDown += ::GetSystemMetrics(SM_CXVSCROLL);
		}
	}

    CRect rcComboBox(0, 0, 0, 0);
	GetWindowRect(rcComboBox);
	if(m_nWidthDropDown!=-1 && m_nWidthDropDown!=GetDroppedWidth())
	{
		if(rcComboBox.Width() < m_nWidthDropDown)
			SetDroppedWidth(m_nWidthDropDown);
	}
}

void CNMImgComboBox::SetTextColor(COLORREF crText)
{
	m_crText=crText;
	Invalidate();
}

void CNMImgComboBox::AddWorldTimeStrings()
{
	CString strString;
	strString.LoadString(IDS_STRING178);
	AddString(strString);//GMT -12:00 ¥ 漱 	
	strString.LoadString(IDS_STRING179);
	AddString(strString);//GMT -11:00 -11
	strString.LoadString(IDS_STRING180);
	AddString(strString);//GMT -10:00 Ͽ
	strString.LoadString(IDS_STRING181);
	AddString(strString);//GMT -9:00 ˷ī
	strString.LoadString(IDS_STRING182);
	AddString(strString);//GMT -8:00 , ĶϾ,  ǥؽ
	strString.LoadString(IDS_STRING183);
	AddString(strString);//GMT -7:00 ǥؽ, ָ, ġͿ, Ľ, Ʋ
	strString.LoadString(IDS_STRING184);
	AddString(strString);//GMT -6:00 ޶϶, ߽ڽƼ, ׷, ĳó, ߺǥؽ, ߾ӾƸ޸ī
	strString.LoadString(IDS_STRING185);
	AddString(strString);//GMT -5:00 ǥؽ, Ÿ, , Ű, εֳ
	strString.LoadString(IDS_STRING186);
	AddString(strString);//GMT -4:00 뼭 ǥؽ, ĳ, Ƽư, Ƽÿ, Ÿ, Ľ, 뽺, ľ, ̾ƹ
	strString.LoadString(IDS_STRING187);
	AddString(strString);//GMT -3:00 ׸, ׺, ο뽺̷, , ٵ, ī, Ż
	strString.LoadString(IDS_STRING188);
	AddString(strString);//GMT -2:00 ߺ-뼭, ð-02
	strString.LoadString(IDS_STRING189);
	AddString(strString);//GMT -1:00 , ī, 
	strString.LoadString(IDS_STRING190);
	AddString(strString);//GMT +0:00 , , , , κ, ļũ, īī, 
	strString.LoadString(IDS_STRING191);
	AddString(strString);//GMT +1:00 ׶, Ƽ, δ佺Ʈ, , , , ϰ, 帮, ĸ, Ʈũ, 󿹺, , ٸ, ڱ׷, ߾Ӿī, Ͻ׸, , , θ, Ȧ, 
	strString.LoadString(IDS_STRING192);
	AddString(strString);//GMT +2:00 ڽþ ٸ ̷Ʈ ׳ īƮ ϸ 췽 ̽ź ī̷ ϶ 丮 Ű ⿹  Ǿ Ż 
	strString.LoadString(IDS_STRING193);
	AddString(strString);//GMT +3:00 ̷κ, ٱ״ٵ, Įѱ׶, νũ, Ʈ, ߵ
	strString.LoadString(IDS_STRING194);
	AddString(strString);//GMT +3:30 
	strString.LoadString(IDS_STRING195);
	AddString(strString);//GMT +4:00 ũ, Ʈ׸θũ, ׶, , ƶ, ƺδٺ, īƮ, , Ʈ, Ʈ̽
	strString.LoadString(IDS_STRING196);
	AddString(strString);//GMT +4:30 ī
	strString.LoadString(IDS_STRING197);
	AddString(strString);//GMT +5:00 ̽󸶹ٵ, īġ, ŸƮ
	strString.LoadString(IDS_STRING198);
	AddString(strString);//GMT +5:30 ھ߿͸Ǫ, þ, īŸ, , 
	strString.LoadString(IDS_STRING199);
	AddString(strString);//GMT +5:45 īƮ
	strString.LoadString(IDS_STRING200);
	AddString(strString);//GMT +6:00 ī, ƽŸ, ī׸θũ
	strString.LoadString(IDS_STRING201);
	AddString(strString);//GMT +6:30 
	strString.LoadString(IDS_STRING202);
	AddString(strString);//GMT +7:00 뺸ú񸣽ũ, , ϳ, īŸ
	strString.LoadString(IDS_STRING203);
	AddString(strString);//GMT +8:00 ¡, Ī, ȫƯ, 繫ġ, ٷƮ, Ǫ, ̰, ũ󽺳߸ũ, Ÿ̺ ۽
	strString.LoadString(IDS_STRING204);
	AddString(strString);//GMT +9:00 , ī, , 
	strString.LoadString(IDS_STRING205);
	AddString(strString);//GMT +9:30 , ֵ鷹̵
	strString.LoadString(IDS_STRING206);
	AddString(strString);//GMT +10:00 , Ʈ, 긮, ũ, ĵ, , õ ȣƮ
	strString.LoadString(IDS_STRING207);
	AddString(strString);//GMT +11:00 𺸽ũ, ַθ, ĮϾ
	
	strString.LoadString(IDS_STRING540);
	AddString(strString);//GMT +11:30 ũ Ϸ
	
	strString.LoadString(IDS_STRING208);
	AddString(strString);//GMT +12:00 , Ŭ,  , +12
	
	//strString.LoadString(IDS_STRING209);
	//AddString(strString);//GMT +13:00 , ˷, 
}

CString CNMImgComboBox::GetWorldTimeString(int index)
{
	CString result(_T(""));

	if (index >= 0 && index <= 15)
	{
		if ((index - 12) > 0)
		{
			result.Format(_T("+%d"), index - 12);
		}
		else
		{
			result.Format(_T("%d"), index - 12);
		}
	}
	else
	{

		switch (index)
		{
		case 16:
			result = _T("+3.5");
			break;
		case 17:
			result = _T("+4");
			break;
		case 18:
			result = _T("+4.5");
			break;
		case 19:
			result = _T("+5");
			break;
		case 20:
			result = _T("+5.5");
			break;
		case 21:
			result = _T("+5.75");
			break;
		case 22:
			result = _T("+6");
			break;
		case 23:
			result = _T("+6.5");
			break;
		case 24:
			result = _T("+7");
			break;
		case 25:
			result = _T("+8");
			break;
		case 26:
			result = _T("+9");
			break;
		case 27:
			result = _T("+9.5");
			break;
		case 28:
			result = _T("+10");
			break;
		case 29:
			result = _T("+11");
			break;
		case 30:
			result = _T("+11.5");
			break;
		case 31:
			result = _T("+12");
			break;
		}
	}

	return result;
}

